---
title: ARIA page template
slug: MDN/Structures/Page_types/ARIA_Page_Template
tags:
  - CSS
  - Property
  - Reference
  - Template
---
<div> {{MDNSidebar}}</div>

<div class="note">
<h2 id="Remove_before_publishing">Remove before publishing</h2>

<h3 id="Title_and_slug">Title and slug</h3>

<p>An ARIA role page should have a <em>title</em> and <em>slug</em> of<em> ARIA:Name</em>Of<em>TheRole</em>. For example, the <a href="/en-US/docs/Web/Accessibility/ARIA/ARIA_Techniques/Using_the_button_role">button role</a> has a <em>title</em> and <em>slug</em> of <em>ARIA/NameOfTheRole_role</em> and the <a href="https://developer.mozilla.org/en/Accessibility/ARIA/ARIA_Techniques/Using_the_aria-labelledby_attribute" title="en/ARIA/ARIA_Techniques/Using_the_aria-labelledby_attribute">aria-labelledby </a>attribute has a title of <em>ARIA-labeledby Attribute.</em></p>

<h3 id="Top_macros">Top macros</h3>

<p>By default, there are four macro calls at the top of the template. You should update or delete them according to the following advice:</p>

<ul>
 <li>\{{draft()}}—generates a <strong>Draft</strong> banner that indicates that the page is incomplete, and should only be removed when the first draft of the page is completely finished. After it is ready to be published, you can remove this.</li>
 <li>\{{deprecated_header}}—generates a <strong>Deprecated</strong> banner that indicates the technology is <a href="/en-US/docs/MDN/Contribute/Guidelines/Conventions_definitions#Deprecated_and_obsolete">deprecated</a>. If it isn't, then you can remove the macro call.</li>
 <li>
  <div>\{{ariaref}}—generates a suitable ARIA sidebar, depending on what tags are included on the page.</div>
 </li>
</ul>

<h3 id="Tags">Tags</h3>

<p>In ARIA role or attribute subpages, you need to include the following tags (see the <em>Tags</em> section at the bottom of the editor UI): <strong>ARIA</strong>, <strong>Reference</strong>, <strong>ARIA Role </strong>or<strong> ARIA Attribute</strong>, <em>the name of the Role or Attribute</em> (e.g. <strong>ARIA button</strong> or <strong>aria-labeledby</strong>), <strong>ARIA widget,</strong> <strong>Experimental</strong> (if the role or attribute is <a href="/en-US/docs/MDN/Contribute/Guidelines/Conventions_definitions#Experimental">experimental</a>), and <strong>Deprecated</strong> (if it is <a href="/en-US/docs/MDN/Contribute/Guidelines/Conventions_definitions#Deprecated_and_obsolete">deprecated</a>).</p>

<h3 id="Specifications">Specifications</h3>

<p>Update the fragment link within the following specifications to the correct section:</p>

<ul>
 <li>ARIA: https://www.w3.org/TR/wai-aria-1.1/</li>
 <li><span class="blob-code-inner blob-code-marker-addition"><span class="pl-s">ARIA Authoring Practices</span></span>: https://www.w3.org/TR/wai-aria-practices-1.1/</li>
</ul>

<p>Additional resources:</p>

<ul>
 <li>Accessibilty Object Model: https://wicg.github.io/aom/spec/</li>
 <li>ARIA in HTML: https://w3c.github.io/html-aria/</li>
</ul>
</div>

<div>{{draft}}\{{ariaref}}</div>

<p>The summary paragraph—start by naming the role or attribute and saying what it does. This should ideally be 1 or 2 short sentences. This content appears as a tool tip on links to this page, so craft it well.</p>

<pre class="brush: html notranslate">&lt;!-- Insert code block showing common use cases --&gt;
</pre>

<p>(Optional) Include a short description of the preceding example.</p>

<h2 id="Description">Description</h2>

<p>Include a complete description of the attribute or role.</p>

<h3 id="Associated_ARIA_roles_states_and_properties">Associated ARIA roles, states, and properties</h3>

<dl>
 <dt>Name of associated roles</dt>
 <dd>Explaination of requirement, link to features pages.</dd>
 <dt>Name of associated attribute(s)</dt>
 <dd>Explaination of requirement, link to attribute's pages, along with link to JS required to change the value, if appropriate.</dd>
</dl>


<h3 id="Keyboard_interactions">Keyboard interactions</h3>


<h3 id="Required_JavaScript_features">Required JavaScript features</h3>

<dl>
 <dt>Required event handlers</dt>
 <dd>Explanation of each</dd>
 <dt>Changing attribute values</dt>
 <dd>explanation of each</dd>
</dl>

<div class="note">
<p>Include a note about semantic alternatives to using this role or attribute. <span class="ILfuVd yZ8quc">The first rule of ARIA use is that you can use a native feature with the semantics and behavior you require already built in, instead of re-purposing an element and <strong>adding</strong> an ARIA role, state, or property to make it accessible, then do so. Then post full details in best practices section below.</span></p>
</div>

<h2 id="Examples">Examples</h2>

<p>Fill in a simple example that shows a typical usage of the property, then perhaps some more complex examples. For more information, see our guide on how to add <a href="/en-US/docs/MDN/Contribute/Structures/Code_examples">code examples</a>.</p>

<pre class="brush: html notranslate">my code block</pre>

<p>And/or include a list of links to useful code samples that live elsewhere:</p>

<ul>
 <li>x</li>
 <li>y</li>
 <li>z</li>
</ul>

<h2 id="Accessibility_concerns">Accessibility concerns</h2>

<p>Optionally, warn of any potential accessibility concerns that exist with using this property, and how to work around them. Remove this section if there are none to list.</p>

<h2 id="Best_practices">Best practices</h2>

<p>Optionally, list any best practices that exist for this role. Remove the section if none exist.</p>

<h3 id="Added_benefits">Added benefits</h3>

<dl>
 <dt>Associated role</dt>
 <dd>If that role is a required parent, child or sibling, and what it does.</dd>
</dl>

<p>Any additional benefits this feature has for non-typical screen reader users, like Google or mobile speech recognition.</p>

<h2 id="Specifications_2">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
  </tr>
  <tr>
   <td>{{SpecName("ARIA","#direct-document-fragment-link","NameOfRoleOrAttribute")}}</td>
   <td>{{Spec2('ARIA')}}</td>
  </tr>
  <tr>
   <td>{{SpecName("ARIA Authoring Practices","#direct-document-fragment-link","NameOfRoleOrAttribute")}}</td>
   <td>{{Spec2('ARIA Authoring Practices')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Precedence_order">Precedence order</h2>

<p>What are the related properties, and in what order will this attribute or property be read (which property will take precendence over this one, and which property will be overwritten.</p>

<h2 id="Screen_reader_support">Screen reader support</h2>


<h2 id="See_also">See also</h2>


<ul>
 <li>Include list of</li>
 <li>other links related to</li>
 <li>this role or attribute that might</li>
 <li>be useful</li>
</ul>
